ScriptName Apropos Extends Quest

SexLabFramework Property SexLab  Auto
AproposConfig Property Config Auto
AproposDescriptions Property Descriptions Auto
AproposDescriptionDb Property Database Auto
AproposCommon Property Common Auto
Actor Property PlayerRef Auto
slaUtilScr Property SlaUtil Auto

Import AproposUtil

AproposActorAlias Property Actor00 Auto
AproposActorAlias Property Actor01 Auto
AproposActorAlias Property Actor02 Auto
AproposActorAlias Property Actor03 Auto
AproposActorAlias Property Actor04 Auto
AproposActorAlias Property Actor05 Auto
AproposActorAlias Property Actor06 Auto
AproposActorAlias Property Actor07 Auto
AproposActorAlias Property Actor08 Auto
AproposActorAlias Property Actor09 Auto
AproposActorAlias Property Actor10 Auto
AproposActorAlias Property Actor11 Auto
AproposActorAlias Property Actor12 Auto
AproposActorAlias Property Actor13 Auto
AproposActorAlias Property Actor14 Auto
AproposActorAlias Property Actor15 Auto
AproposActorAlias Property Actor16 Auto
AproposActorAlias Property Actor17 Auto
AproposActorAlias Property Actor18 Auto
AproposActorAlias Property Actor19 Auto
AproposActorAlias[] Property Actors Auto Hidden

Event OnInit()
    Debug.OpenUserLog("Apropos")
    Config.Log("Apropos.OnInit", True)

    If (!Config.IsJCValid)
        Return
    EndIf

    SetUpAproposActors()
    RegisterForSexLabEvents()

    _widgetTestHotkey = DefaultWidgetTestHotkey

    Config.Log("Apropos Ready", True, True)
EndEvent

Function GameLoaded()
    Config.Log("Apropos.GameLoaded", True)

    UnregisterForSexLabEvents()

    If (!Config.IsJCValid)
        Return
    EndIf

    If !Actors
        SetUpAproposActors()
    EndIf
    RegisterForSexLabEvents()

    If (Config.AreDebugMessagesEnabled())
        Config.Log("Apropos Ready", True)
    EndIf   
EndFunction

Function RegisterForSexLabEvents()
    RegisterForModEvent("HookOrgasmStart", "OrgasmStart")
    ;RegisterForModEvent("HookOrgasmEnd", "OrgasmEnd")
    RegisterForModEvent("HookAnimationStart", "AnimationStart")
    RegisterForModEvent("HookAnimationChange", "AnimationChange")
    RegisterForModEvent("HookStageStart", "StageStart")
    ;RegisterForModEvent("StageEnd", "StageEnd" )
    ;RegisterForModEvent("ActorChangeStart", "ActorChangeStart")
    ;RegisterForModEvent("ActorChangeEnd", "ActorChangeEnd")
    ;RegisterForModEvent("PositionChange", "PositionChange")
    RegisterForModEvent("AproposDisplayMessage", "AproposDisplayMessage")
    RegisterForModEvent("AproposInitWT", "AproposInitWT")
EndFunction

Function UnregisterForSexLabEvents()
    UnregisterForModEvent("HookOrgasmStart")
    UnregisterForModEvent("HookOrgasmEnd")
    UnregisterForModEvent("HookAnimationStart")
    UnregisterForModEvent("HookAnimationChange")
    UnregisterForModEvent("HookStageStart")
    UnregisterForModEvent("HookStageEnd")
    UnregisterForModEvent("HookActorChangeStart")
    UnregisterForModEvent("HookActorChangeEnd")
    UnregisterForModEvent("HookPositionChange")
    UnregisterForModEvent("AproposDisplayMessage")
    UnregisterForModEvent("AproposInitWT")
EndFunction

Function SetUpAproposActors()
    Config.Log("Apropos.SetUpAproposActors", True)
    Actors = New AproposActorAlias[20]
    Actors[0] = Actor00
    Actors[1] = Actor01
    Actors[2] = Actor02
    Actors[3] = Actor03
    Actors[4] = Actor04
    Actors[5] = Actor05
    Actors[6] = Actor06
    Actors[7] = Actor07
    Actors[8] = Actor08
    Actors[9] = Actor09
    Actors[10] = Actor10
    Actors[11] = Actor11
    Actors[12] = Actor12
    Actors[13] = Actor13
    Actors[14] = Actor14
    Actors[15] = Actor15
    Actors[16] = Actor16
    Actors[17] = Actor17
    Actors[18] = Actor18
    Actors[19] = Actor19
EndFunction

Event AproposInitWT(Form aForm, Int vaginalLevel, Int analLevel, Int oralLevel, Bool updateAbuse, Bool updateCreatureAbuse, Bool updateDaedricAbuse) 
    Actor anActor = aForm as Actor

    If !anActor
        Return
    EndIf

    LogToAll("AproposInitWT called for actor " + anActor.GetDisplayName() + "V:" + vaginalLevel + "A:" + analLevel + "O:" + oralLevel)

    If vaginalLevel < 0 || vaginalLevel > 9 
        Return
    EndIf

    If analLevel < 0 || analLevel > 9 
        Return
    EndIf

    If oralLevel < 0 || oralLevel > 9 
        Return
    EndIf

    AproposActorAlias aproposActor = GetTrackedActorOrStartTracking(anActor)
    If aproposActor
        aproposActor.OverrideVaginalWT(vaginalLevel, updateAbuse, updateCreatureAbuse, updateDaedricAbuse)
        aproposActor.OverrideAnalWT(analLevel, updateAbuse, updateCreatureAbuse, updateDaedricAbuse)
        aproposActor.OverrideOralWT(oralLevel, updateAbuse, updateCreatureAbuse, updateDaedricAbuse)

        aproposActor.UpdateAbuseTextures()
        aproposActor.UpdateWearTearEffects()
    EndIf

    LogToAll("AproposInitWT processed!")

EndEvent

Event AproposDisplayMessage(int mapId)
    If !Self || !SexLab || !Config
        Error("Critical error - AproposDisplayMessage")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    Config.Log("AproposDisplayMessage called with valid map : " + CheckIsJMap(mapId), True)
    If CheckIsJMap(mapId)
        Int keysId = JMap.allKeys(mapId)
        Int i = JArray.Count(keysId)
        While i > 0
            i -= 1
            String k = JArray.getStr(keysId, i)
            Config.Log("Key : " + k, True)
            Config.Log("Value : " + JMap.getStr(mapId, k), True)
        EndWhile
    EndIf

EndEvent

Event OrgasmStart(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - OrgasmStart")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogEventInfo("OrgasmStart", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf  
    
    Descriptions.DisplayOrgasmStartMessage(thread)
EndEvent

Event AnimationStart(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - AnimationStart")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogEventInfo("AnimationStart", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf 
    
    Descriptions.DisplayAnimationStartChangeOrStageStartMessage(thread, 0, False)
EndEvent

Event AnimationChange(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - AnimationChange")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogEventInfo("AnimationChange", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf 
    
    Descriptions.DisplayAnimationStartChangeOrStageStartMessage(thread, 0, True)
EndEvent

Event StageStart(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - StageStart")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogAnimationStage("StageStart", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf

    Descriptions.DisplayAnimationStartChangeOrStageStartMessage(thread, thread.Stage, False)
EndEvent

Event StageEnd(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - StageEnd")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogAnimationStage("StageEnd", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf

    Descriptions.DisplayStageEndMessage(thread, thread.Stage)    
EndEvent

Event ActorChangeStart(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - ActorChangeStart")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogEventInfo("ActorChangeStart", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf    
        
    Descriptions.DisplayActorChangeStartMessage(thread) 
EndEvent

Event ActorChangeEnd(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - ActorChangeEnd")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
        Config.LogEventInfo("ActorChangeEnd", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf
        
    Descriptions.DisplayActorChangeEndMessage(thread) 
EndEvent

Event PositionChange(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - PositionChange")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)
    
    If Config.AreDebugMessagesEnabled()
       Config. LogEventInfo("PositionChange", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf
        
    Descriptions.DisplayPositionChangeMessage(thread) 
EndEvent

Event OrgasmEnd(int threadID, bool HasPlayer)
    If !Self || !SexLab || !Config
        Error("Critical error - OrgasmEnd")
        Return
    EndIf
    
    If !Config.IsModEnabled
        Return
    EndIf

    SslThreadController thread = SexLab.GetController(threadID)    
    
    If Config.AreDebugMessagesEnabled()
        Config.LogEventInfo("OrgasmEnd", thread, slaUtil, Config.LogActorStatsEnabled)
    EndIf
        
    Descriptions.DisplayOrgasmEndMessage(thread) 
EndEvent

AproposActorAlias Function GetActorWithId(Int id)
    If id > -1
        Return Actors[id]
    EndIf
    Return None
EndFunction

Int Function GetNextAvailableActorSlot()
    Int i = 0
    While i < Actors.Length
        If Actors[i].GetState() == "ReadyForTracking"
            Return i
        EndIf
        i += 1
    EndWhile
    Return -1
EndFunction

Bool Function ShouldApplyWearAndTear(Actor anActor)
    If !Config.IsWearAndTearEnabled
        Return False
    EndIf

    If !Config.IsNPCWearAndTearEnabled && anActor != PlayerRef
        Return False
    EndIf   

    Return True
EndFunction

AproposActorAlias Function GetTrackedActorOrStartTracking(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor
    EndIf
    String actorName = anActor.GetDisplayName()
    If Config.AreTraceMessagesEnabled()
        Config.Log(actorName + " was not being tracked. Start tracking now...")
    EndIf    
    aproposActor = TrackActor(anActor)
    Return aproposActor
EndFunction

Function UpdateWearTearEffectsAndAbuseTextures(Actor anActor)
    AproposActorAlias aproposActor = GetTrackedActorOrStartTracking(anActor)
    If aproposActor
        aproposActor.LogAllWearAndTear()
        aproposActor.UpdateWearTearEffects()
        aproposActor.UpdateAbuseTextures()
    EndIf
EndFunction

Function ApplyVaginalWearAndTear(Actor anActor, string damageClass, Bool isRapeOrAggressive, Bool isDaedricCreatureOrDremora, Bool isCreature)
    If !ShouldApplyWearAndTear(anActor)
        Return
    EndIf   

    String actorName = anActor.GetDisplayName()
    If Config.AreTraceMessagesEnabled()
        Config.Log("Apropos.ApplyVaginalWearAndTear(" + actorName + "," + damageClass + "," + isRapeOrAggressive + ")")
    EndIf

    AproposActorAlias aproposActor = GetTrackedActorOrStartTracking(anActor)
    If aproposActor
        Int amount = Database.GetWearTearDamage(damageClass, isRapeOrAggressive)
        aproposActor.IncreaseVaginalWearAndTear(amount)
        aproposActor.IncreaseVaginalAbuseWearAndTear(amount, isRapeOrAggressive, isDaedricCreatureOrDremora, isCreature)
    EndIf
EndFunction

Function ApplyAnalWearAndTear(Actor anActor, string damageClass, Bool isRapeOrAggressive, Bool isDaedricCreatureOrDremora, Bool isCreature)
    If !ShouldApplyWearAndTear(anActor)
        Return
    EndIf   

    String actorName = anActor.GetDisplayName()
    If Config.AreTraceMessagesEnabled()
        Config.Log("Apropos.ApplyAnalWearAndTear(" + actorName + "," + damageClass + "," + isRapeOrAggressive + ")")
    EndIf

    AproposActorAlias aproposActor = GetTrackedActorOrStartTracking(anActor)
    If aproposActor
        Int amount = Database.GetWearTearDamage(damageClass, isRapeOrAggressive)
        aproposActor.IncreaseAnalWearAndTear(amount)
        aproposActor.IncreaseAnalAbuseWearAndTear(amount, isRapeOrAggressive, isDaedricCreatureOrDremora, isCreature)
    EndIf
EndFunction

Function ApplyOralWearAndTear(Actor anActor, string damageClass, Bool isRapeOrAggressive, Bool isDaedricCreatureOrDremora, Bool isCreature)
    If !ShouldApplyWearAndTear(anActor)
        Return
    EndIf   

    String actorName = anActor.GetDisplayName()
    If Config.AreTraceMessagesEnabled()
        Config.Log("Apropos.ApplyOralWearAndTear(" + actorName + "," + damageClass + "," + isRapeOrAggressive + ")")
    EndIf

    AproposActorAlias aproposActor = GetTrackedActorOrStartTracking(anActor)
    If aproposActor
        Int amount = Database.GetWearTearDamage(damageClass, isRapeOrAggressive)
        aproposActor.IncreaseOralWearAndTear(amount)
        aproposActor.IncreaseOralAbuseWearAndTear(amount, isRapeOrAggressive, isDaedricCreatureOrDremora, isCreature)
    EndIf
EndFunction

Int Function GetWearTearVaginalState(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor.VaginalWearTearState
    EndIf
    Return 0
EndFunction

Int Function GetWearTearAnalState(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor.AnalWearTearState
    EndIf
    Return 0
EndFunction

Int Function GetWearTearOralState(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor.OralWearTearState
    EndIf
    Return 0
EndFunction

String Function GetWearTearVaginal(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor.VaginalWearTear
    EndIf
    Return ""
EndFunction

String Function GetWearTearAnal(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor.AnalWearTear
    EndIf
    Return ""
EndFunction

String Function GetWearTearOral(Actor anActor)
    AproposActorAlias aproposActor = GetAproposActor(anActor)
    If aproposActor
        Return aproposActor.OralWearTear
    EndIf
    Return ""
EndFunction

AproposActorAlias Function TrackActor(Actor anActor)
    If anActor.GetActorBase().IsUnique() && IsNotTracked(anActor)
        Int nextSlot = GetNextAvailableActorSlot()
        If (nextSlot > -1)
            AproposActorAlias actorAlias = Actors[nextSlot]
            Config.Log("Using next slot " + nextSlot + " actorAlias is alive: " + actorAlias.TestIsAlive())
            Config.Log(actorAlias)
            Config.Log(nextSlot)
            actorAlias.Track(anActor, nextSlot)
            Return actorAlias
        EndIf
    EndIf
    Return None
EndFunction

AproposActorAlias Function GetAproposActor(Actor anActor)
    String actorName = anActor.GetDisplayName()
    If Config.AreTraceMessagesEnabled()
        Config.Log("Apropos.GetAproposActor(Actor=" + actorName + ")")
    EndIf

    Int i = 0
    While i < Actors.Length
        If Actors[i].GetState() != "ReadyForTracking" && Actors[i].GetActor() == anActor
            Config.Log("Found AproposActorAlias the represents the actor.")
            Return Actors[i]
        EndIf
        i += 1
    EndWhile
    
    Return None
EndFunction

Bool Function IsNotTracked(Actor actorToTest)
    String actorName = actorToTest.GetDisplayName()
    Int i = 0
    While i < Actors.Length
        If Actors[i].GetState() != "ReadyForTracking" && Actors[i].GetActor() == actorToTest
            If Config.AreTraceMessagesEnabled()
                Config.Log(actorName + " is being tracked")    
            EndIf
            Return False
        EndIf
        i += 1
    EndWhile
    If Config.AreTraceMessagesEnabled()
        Config.Log(actorName + " is not being tracked")    
    EndIf
    Return True
EndFunction

Function ClearTrackedNPCActors()
    Int i = 0
    While i < Actors.Length
        AproposActorAlias anAlias = Actors[i]
        If anAlias != "ReadyForTracking" && anAlias.GetActor() != PlayerRef
            Actors[i].GoToState("ClearTracking")
        EndIf
        i += 1
    EndWhile
    Config.NPCTrackingsCleared()
    Config.Log("All named NPC trackings removed", True)
EndFunction

Function ClearPlayerActorTracking()
    AproposActorAlias playerAlias = GetAproposActor(PlayerRef)
    If playerAlias
        playerAlias.GoToState("ClearTracking")
        Config.PCTrackingCleared()
        Config.Log("PC tracking removed", True)    
    EndIf
EndFunction

String[] Function GetTrackedActorList()
    Int size
    Bool isDouble = Config.EnableSkinTextures
    If isDouble
        size = 40
    Else
        size = 20
    EndIf

    String[] list = SslUtility.StringArray(size)
    Int i = 0
    Int j 
    While i < Actors.Length
        AproposActorAlias a = Actors[i]
        If Config.AreDebugMessagesEnabled()
            Actor trackedActor = a.GetActor()
            If trackedActor
                Config.Log("i: " + i + " state: " + a.GetState() + " actor : " + a.GetActor().GetDisplayName())
            Else
                Config.Log("i: " + i + " state: " + a.GetState() + " actor : none")
            EndIf
        EndIf
        If isDouble
            j = i * 2
        Else
            j = i
        EndIf        
        If a.GetState() == "TrackingWearAndTear" && a.GetActor() != PlayerRef
           list[j] = a.GetActor().GetDisplayName() + " Vaginal:" + a.VaginalWearTearState + " Anal:" + a.AnalWearTearState + " Oral:" + a.OralWearTearState
            If isDouble
                list[j+1] = "... abuse:" + a.AverageAbuseState + " creature: " + a.AverageCreatureAbuseState + " daedric : " + a.AverageDaedricAbuseState
            EndIf
        Else
            list[j] = ""
            If isDouble
                list[j+1] = ""
            EndIf
        EndIf
        i += 1

    EndWhile
    Return list
EndFunction

Int _widgetTestHotkey = -1
Int Property DefaultWidgetTestHotkey = -1 AutoReadonly

Int Property WidgetTestHotkey
    Int Function get()
        Return _widgetTestHotkey
    EndFunction

    Function set(Int a_val)
        If a_val != _widgetTestHotkey
            UnregisterForAllKeys()
            _widgetTestHotkey = a_val
            If _widgetTestHotkey != -1
                RegisterForKey(_widgetTestHotkey)
            EndIf
        EndIf
    EndFunction
EndProperty

Event OnKeyDown(Int keyCode)
    If keyCode == _widgetTestHotkey
        Config.PerformWidgetVisualTest()
    EndIf
EndEvent

Event Stop()
    UnregisterForAllKeys()
    Parent.Stop()
EndEvent