ScriptName AproposUtil hidden
{Global Utility functions for Apropos}

; Creates a properly namespaced storage key for storing into JDB, given a regular key
String Function StoreKey(String aKey) Global
    String res = "apropos_" + aKey
    Return res
EndFunction

; Creates a properly namespaced storage key for querying JDB, given a regular key, and a optional subkey
String Function QueryKey(String aKey, String bKey = "", String cKey = "") Global
    String res = ".apropos_" + aKey
    If bKey != ""
        res += "."
        res += bKey
    EndIf

    If cKey != ""
        res += "."
        res += cKey
    EndIf    

    Return res
EndFunction

String Function GetKey(String aKey) Global
    Return "apropos_" + aKey
EndFunction

Int Function GetIntValue(Form target, String storageKey) Global
    Int res = JFormDB.getInt(target, ".apropos_actors." + storageKey)
    ;ToUserLog("GetIntValue(" + target + ",.apropos_actors." + storageKey + ") = " + res)
    Return res
EndFunction

Float Function GetFloatValue(Form target, String storageKey) Global
    Float res = JFormDB.getFlt(target, ".apropos_actors." + storageKey)
    ;ToUserLog("GetFloatValue(" + target + ",.apropos_actors." + storageKey + ") = " + res)
    Return res
EndFunction

String Function GetStringValue(Form target, String storageKey) Global
    String res = JFormDB.getStr(target, ".apropos_actors." + storageKey)
    ;ToUserLog("GetStringValue(" + target + ",.apropos_actors." + storageKey + ") = " + res)
    Return res
EndFunction

Function SetIntValue(Form target, String storageKey, Int intValue) Global
    ;ToUserLog("SetIntValue(" + target + ",.apropos_actors." + storageKey + "," + intValue)
    JFormDB.setInt(target, ".apropos_actors." + storageKey, intValue)
EndFunction

Function SetFloatValue(Form target, String storageKey, Float floatValue) Global
    JFormDB.setFlt(target, ".apropos_actors." + storageKey, floatValue)
EndFunction

Function SetStringValue(Form target, String storageKey, String stringValue) Global
    JFormDB.setStr(target, ".apropos_actors." + storageKey, stringValue)
EndFunction

Function ClearStringValue(Form target, String storageKey) Global
    SetStringValue(target, storageKey, "")
EndFunction

String Function CreateTestSentence(Int min = 5, Int max = 15) Global
    String[] words = CreateTestWords()
    Int numWords = Utility.RandomInt(min, max)
    String sentence = ""
    While numWords > 0
        numWords -= 1
        sentence = sentence + " " + words[Utility.RandomInt(1, words.Length - 1)]
    EndWhile
    Return sentence
EndFunction

String[] Function CreateTestWords() Global
    String[] words = SslUtility.StringArray(50)
    words[0] = "Donec"
    words[1] = "euismod"
    words[2] = "urna"
    words[3] = "at"
    words[4] = "semper"
    words[5] = "aliquam"
    words[6] = "turpis"
    words[7] = "tortor"
    words[8] = "interdum"
    words[9] = "est"

    words[10] = "eu"
    words[11] = "condimentum"
    words[12] = "dui"
    words[13] = "tortor"
    words[14] = "at"
    words[15] = "felis"
    words[16] = "turpis"
    words[17] = "Vivamus"
    words[18] = "ac"
    words[19] = "cursus"

    words[20] = "leo"
    words[21] = "Morbi"
    words[22] = "ut"
    words[23] = "justo"
    words[24] = "ut"
    words[25] = "tortor"
    words[26] = "molestie"
    words[27] = "vestibulum"
    words[28] = "at"
    words[29] = "at"

    words[30] = "mauris"
    words[31] = "Phasellus"
    words[32] = "odio"
    words[33] = "odio"
    words[34] = "placerat"
    words[35] = "sed"
    words[36] = "consequat"
    words[37] = "a"
    words[38] = "sollicitudin"
    words[39] = "ut"

    words[40] = "Fusce"
    words[41] = "purus"
    words[42] = "ante"
    words[43] = "eros"
    words[44] = "scelerisque"
    words[45] = "risus"
    words[46] = "Etiam"
    words[47] = "convallis"
    words[48] = "Proin"
    words[49] = "sodales"    

    return words
EndFunction

String[] Function Strings(String val1, String val2 = "", String val3 = "", String val4 = "", String val5 = "", String val6 = "", String val7 = "", String val8 = "") Global
    If !val2
        String[] ar = SslUtility.StringArray(1)
        ar[0] = val1
        return ar
    EndIf
    If !val3
        String[] ar = SslUtility.StringArray(2)
        ar[0] = val1
        ar[1] = val2
        return ar
    EndIf
    If !val4
        String[] ar = SslUtility.StringArray(3)
        ar[0] = val1
        ar[1] = val2
        ar[2] = val3
        return ar
    EndIf
    If !val5
        String[] ar = SslUtility.StringArray(4)
        ar[0] = val1
        ar[1] = val2
        ar[2] = val3
        ar[3] = val4
        return ar
    EndIf
    If !val6
        String[] ar = SslUtility.StringArray(5)
        ar[0] = val1
        ar[1] = val2
        ar[2] = val3
        ar[3] = val4
        ar[4] = val5
        return ar
    EndIf
    If !val7
        String[] ar = SslUtility.StringArray(6)
        ar[0] = val1
        ar[1] = val2
        ar[2] = val3
        ar[3] = val4
        ar[4] = val5
        ar[5] = val6
        return ar
    EndIf
    If !val8
        String[] ar = SslUtility.StringArray(7)
        ar[0] = val1
        ar[1] = val2
        ar[2] = val3
        ar[3] = val4
        ar[4] = val5
        ar[5] = val6
        ar[6] = val7
        return ar
    EndIf     
EndFunction

String[] Function CreateStringArray1(String val1) Global
    String[] values = New String[1]
    values[0] = val1
    Return values
EndFunction

String[] Function CreateStringArray2(String val1, String val2) Global
    String[] values = New String[2]
    values[0] = val1
    values[1] = val2
    Return values
EndFunction

String[] Function CreateStringArray3(String val1, String val2, String val3) Global
    String[] values = New String[3]
    values[0] = val1
    values[1] = val2
    values[2] = val3
    Return values
EndFunction

String[] Function CreateStringArray4(String val1, String val2, String val3, String val4) Global
    String[] values = New String[4]
    values[0] = val1
    values[1] = val2
    values[2] = val3
    values[3] = val4
    Return values
EndFunction

String[] Function CreateStringArray5(String val1, String val2, String val3, String val4, String val5) Global
    String[] values = New String[5]
    values[0] = val1
    values[1] = val2
    values[2] = val3
    values[3] = val4
    values[4] = val5
    Return values
EndFunction

String[] Function CreateStringArray6(String val1, String val2, String val3, String val4, String val5, String val6) Global
    String[] values = New String[6]
    values[0] = val1
    values[1] = val2
    values[2] = val3
    values[3] = val4
    values[4] = val5
    values[5] = val6
    Return values
EndFunction

String[] Function CreateStringArray7(String val1, String val2, String val3, String val4, String val5, String val6, String val7) Global
    String[] values = New String[7]
    values[0] = val1
    values[1] = val2
    values[2] = val3
    values[3] = val4
    values[4] = val5
    values[5] = val6
    values[6] = val7
    Return values
EndFunction

String[] Function CreateStringArray8(String val1, String val2, String val3, String val4, String val5, String val6, String val7, String val8) Global
    String[] values = New String[8]
    values[0] = val1
    values[1] = val2
    values[2] = val3
    values[3] = val4
    values[4] = val5
    values[5] = val6
    values[6] = val7
    values[7] = val8
    Return values
EndFunction

; Creates a new JMap instance using initial key and value
Int Function InitialMapWithString(String initialKey, String initialValue)
    Int mapId = JMap.object()
    JMap.setStr(mapId, initialKey, initialValue)
    Return mapId
EndFunction

; Creates a new JMap instance using initial key and value
Int Function InitialMapWithInt(String initialKey, Int initialValue)
    Int mapId = JMap.object()
    JMap.setInt(mapId, initialKey, initialValue)
    Return mapId
EndFunction

; Creates a new JMap instance using initial key and value
Int Function InitialMapWithFloat(String initialKey, Float initialValue)
    Int mapId = JMap.object()
    JMap.setFlt(mapId, initialKey, initialValue)
    Return mapId
EndFunction

Bool Function StartsWith(String source, String tst) Global
    Int len = StringUtil.GetLength(tst)
    If (len <= 0 || StringUtil.GetLength(source) < len)
        Return False
    EndIf
    
    String subStr = StringUtil.Substring(source, 0, len)
    If (subStr == tst)
        Return True
    EndIf
    Return False
EndFunction

String Function PrependIfNeeded(String source, String prefix) Global
    Bool present = StartsWith(source, prefix)
    If (!present)
        Return prefix + source
    EndIf
    Return source
EndFunction

String Function GetTagsAsString(SslBaseAnimation animation) Global
    String[] tags = animation.GetTags()
    Return StringArrayToString(tags)
EndFunction

String Function StringArrayToString(String[] values) Global
    String result = ""
    Int i = 0
    While i < values.Length
        If values[i]
            result = result + values[i]
            If i < values.Length - 1
                result = result + ","
            EndIf
        EndIf
        i=i+1
    EndWhile
    Return result
EndFunction

Int Function JArrayFromStringArray(String[] array) Global
    Return JArray.objectWithStrings(array)
EndFunction

Bool Function StringContains(String source, String toFind) Global
    Return StringUtil.Find(source, toFind) >= 0
EndFunction

Bool Function CheckIsJArray(Int arrayId) Global
    If !JValue.isArray(arrayId)
        ToUserLog(arrayId + " is not a JArray")
        Return False
    EndIf
    Return True
EndFunction

Bool Function CheckIsJMap(Int mapId) Global
    If !JValue.isMap(mapId)
        ToUserLog(mapId  + " is not a JMap")
        Return False
    EndIf
    Return True
EndFunction

String[] Function StringArrayFromJMapKeys(Int mapId) Global
    If !CheckIsJMap(mapId)
        Return DummyArray()
    EndIf   
    Int allKeysArrayId = JMap.allKeys(mapId)
    Return StringArrayFromJArray(allKeysArrayId)
EndFunction

String[] Function StringArrayFromJArray(Int arrayId) Global
    If arrayId == 0
        Return DummyArray()
    EndIf
    Int count = JArray.count(arrayId)
    String[] results = SslUtility.StringArray(count)
    Int index = 0
    While index < count
        results[index] = JArray.getStr(arrayId, index)
        index += 1
    EndWhile
    Return results
EndFunction

String Function GetGenderName(Int genderIndex) Global
    If genderIndex == 0
        Return "Male"
    ElseIf genderIndex == 1
        Return "Female"
    Else
        Return "Creature"
    EndIf
EndFunction

String Function GenerateSettingsExportPath() Global
    Return JContainers.userDirectory() + "Apropos/MCMUserSettings.txt"
EndFunction

String Function ActorStatsToString(SexLabFramework sexLab, SslThreadController controller, Actor anActor, SlaUtilScr slaUtility) Global
    String result = ""
    If sexLab.IsLewd(anActor)
        result += " <lewd>"
    EndIf
    Int enjoyment = controller.GetEnjoyment(anActor)
    If enjoyment > 0
        result += " <enjoyment:" + enjoyment + ">"
    EndIf
    Int pain = controller.GetPain(anActor)
    If pain > 0
        result += " <pain:" + pain + ">"
    EndIf
    result += " <arousal:" + slaUtility.GetActorArousal(anActor) + ">"
    Return result
EndFunction

Function Error(String mess) Global
    ToConsole(mess)
    ToUserLog(mess)
EndFunction

Function LogToAll(String mess) Global
    ToConsole(mess)
    ToUserLog(mess)
EndFunction

Function ToConsole(String mess) Global
    MiscUtil.PrintConsole("[Apropos] " + mess)
EndFunction

Function ToUserLog(String mess) Global
    Debug.TraceUser("Apropos", mess)
EndFunction

Function TraceStack(String mess) Global
    Debug.TraceStack("[Apropos] " + mess, 0)
EndFunction

Function DisplayMessage(String mess, Int maxSegmentLength = 70, Bool toConsole = False) Global
    ; Display to user log and Skyrim screen
    If (StringUtil.GetLength(mess) <= maxSegmentLength)
        If toConsole
            ToConsole(mess)
        EndIf
        ToUserLog(mess)
        Debug.Notification(mess)
    Else
        Int arrayId = JString.wrap(mess, maxSegmentLength)
        If arrayId == 0
            Error("---------------------------------------------")
            Error("Error calling JString.wrap on string: " + mess)
            Error("---------------------------------------------")
            Error("--- Only ASCII and UTF-8 strings work!    ---")
        Else
            Int i = JArray.count(arrayId)
            While (i > 0)
                i -= 1
                String part = JArray.getStr(arrayId, i)
                If toConsole
                    ToConsole(part)
                EndIf   
                ToUserLog(part)
                Debug.Notification(part)
                
            EndWhile    
        EndIf
    EndIf
    
    Utility.Wait(0.5)
EndFunction	

Function Assert(Bool tst, String failureMessage) Global
    Debug.TraceConditional("[Apropos] Assert Failed: " + failureMessage, !tst)
EndFunction

String Function Substring(String source, Int startIndex, Int len) Global
    If len == 0
        Return ""
    Else
        Return StringUtil.Substring(source, startIndex, len)
    EndIf
EndFunction

String Function TrimEnd(String source) Global
    Int len = StringUtil.GetLength(source)
    If (StringUtil.GetNthChar(source, len - 1) == " ")
        Return Substring(source, 0, len  - 1)
    Else
        Return source
    EndIf
EndFunction

Bool Function CheckFileExists(String fullPath) Global
    If (!JContainers.fileExistsAtPath(fullPath))
        ToUserLog("Could not find or read file '" + fullPath + "'")
        Return False
    EndIf
    Return True
EndFunction

String Function GenerateFullPath(String filename, String subFolder = "", String theme = "") Global
    If !subFolder
        If !theme
            Return "Data/Apropos/db/" + filename + ".txt"
        Else
            Return "Data/Apropos/db/" + theme + "/" + filename + ".txt"
        EndIf
    Else
        If !theme
            Return "Data/Apropos/db/" + subFolder + "/" + filename + ".txt"
        Else
            Return "Data/Apropos/db/" + theme + "/" + subFolder + "/" + filename + ".txt"
        EndIf
    EndIf
EndFunction

String[] Function DummyArray() Global
    String[] result = SslUtility.StringArray(1)
    result[0] = ""
    Return result
EndFunction

Int Function LoadAndStoreJsonFile(String fileName, String storageKey, String theme = "") Global
    LogToAll("Initializing " + fileName + " ... ")

    String fullPath = GenerateFullPath(fileName, theme)
    If !CheckFileExists(fullPath)
        
        If !theme
            Return 0
        EndIf

        ToUserLog("Could not load under " + theme + ". Falling back to default")
        fullPath = GenerateFullPath(fileName)
        If !CheckFileExists(fullPath)
            Return 0
        EndIf
    EndIf
    
    Int rootObjectId = JValue.readFromFile(fullPath)
    If (rootObjectId == 0)
        Error("Could not parse " + fileName + ".txt. Check Json validity at http://jsonlint.com")
        Return 0
    EndIf
    
    JDB.setObj(StoreKey(storageKey), rootObjectId)

    Return rootObjectId
EndFunction

Int Function LoadJsonFile(String fileName) Global
    LogToAll("Loading " + fileName + " ... ")

    String fullPath = GenerateFullPath(fileName)
    If (!CheckFileExists(fullPath))
        Return 0
    EndIf
    
    Int rootObjectId = JValue.readFromFile(fullPath)
    If (rootObjectId == 0)
        Error("Could not parse " + fileName + ".txt. Check Json validity at http://jsonlint.com")
        Return 0
    EndIf
    
    Return rootObjectId
EndFunction

Int Function LoadJsonFromPath(String fullPath) Global
    LogToAll("Loading " + fullPath + " ... ")

    If !CheckFileExists(fullPath)
        Return 0
    EndIf
    
    Int rootObjectId = JValue.readFromFile(fullPath)
    If (rootObjectId == 0)
        Error("Could not parse " + fullPath + ". Check Json validity at http://jsonlint.com")
        Return 0
    EndIf
    
    Return rootObjectId
EndFunction

Int Function Min(Int val1, Int val2) Global
    If val1 < val2 
        Return val1
    EndIf
    Return val2
EndFunction

Int Function Max(Int val1, Int val2) Global
    If val1 > val2 
        Return val1
    EndIf
    Return val2
EndFunction

Int Function Max3(Int val1, Int val2, Int val3) Global 
    Int max1 = Max(val1, val2)
    Return Max(max1, val3)
EndFunction

Int Function Max4(Int val1, Int val2, Int val3, Int val4) Global 
    Int max1 = Max(val1, val2)
    Int max2 = Max(val3, val4)
    Return Max(max1, max2)
EndFunction

Int Function Average3(Int val1, Int val2, Int val3) Global
    Int average = Math.Ceiling(((val1 As Float) + (val2 As Float) + (val3 As Float)) / 3.0)
    Return average
EndFunction

Int Function Average2(Int val1, Int val2) Global
    Int average = Math.Ceiling(((val1 As Float) + (val2 As Float)) / 2.0)
    Return average
EndFunction

Int Function RetainedMap() Global
    Int map = JMap.object()
    JValue.retain(map)
    Return map
EndFunction

Int Function RetainedMap1Pair(String key1, String value1) Global
    Int map = RetainedMap()
    JMap.setStr(map, key1, value1)
    return map
EndFunction

Int Function RetainedMap2Pair(String key1, String value1, String key2, String value2) Global
    Int map = RetainedMap1Pair(key1, value1)
    JMap.setStr(map, key2, value2)
    return map
EndFunction

Int Function RetainedMap3Pair(String key1, String value1, String key2, String value2, String key3, String value3) Global
    Int map = RetainedMap2Pair(key1, value1, key2, value2)
    JMap.setStr(map, key3, value3)
    return map
EndFunction

Int Function RetainedMap4Pair(String key1, String value1, String key2, String value2, String key3, String value3, String key4, String value4) Global
    Int map = RetainedMap3Pair(key1, value1, key2, value2, key3, value3)
    JMap.setStr(map, key4, value4)
    return map
EndFunction